//=========================================================================//
//-------------------------------------------------------------------------//
// nvm3060.h -- Header for for Nvm3060 class                               //
// This file is part of PonyProg.                                          //
//-------------------------------------------------------------------------//
//                                                                         //
//  PonyProg - Serial Device Programmer                                    //
//                                                                         //
//  Copyright (C) 1997-2001  Claudio Lanconelli                            //
//                                                                         //
//  e-mail: lancos@libero.it                                               //
//  http://www.LancOS.com                                                  //
//                                                                         //
//-------------------------------------------------------------------------//
// $Id: nvm3060.h,v 1.1 2004/11/30 17:46:48 lancos Exp $
//-------------------------------------------------------------------------//
//                                                                         //
// This program is free software; you can redistribute it and/or           //
// modify it under the terms of the GNU  General Public License            //
// as published by the Free Software Foundation; either version2 of        //
// the License, or (at your option) any later version.                     //
//                                                                         //
// This program is distributed in the hope that it will be useful,         //
// but WITHOUT ANY WARRANTY; without even the implied warranty of          //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       //
// General Public License for more details.                                //
//                                                                         //
// You should have received a copy of the GNU  General Public License      //
// along with this program (see COPYING);     if not, write to the         //
// Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. //
//                                                                         //
//-------------------------------------------------------------------------//
//=========================================================================//

#ifndef _NVM3060_H
#define _NVM3060_H

#include "types.h"

#include "eeprom.h"
#include "imbus.h"

class Nvm3060 : public Device
{
  public:		//---------------------------------------- public

	Nvm3060(e2AppWinInfo *wininfo = 0, BusIO *busp = 0);
	virtual ~Nvm3060();

	int Probe(int probe_size = 0);
	int Read(int probe = 1, int type = ALL_TYPE);
	int Write(int probe = 1, int type = ALL_TYPE);
	int Verify(int type = ALL_TYPE);

  protected:	//--------------------------------------- protected

	IMBus *GetBus()
		{ return (IMBus *)Device::GetBus(); }

  private:		//--------------------------------------- private

};
#endif
