//=========================================================================//
//-------------------------------------------------------------------------//
// pic168xx.h -- Header for for Pic16F8xx class                            //
// This file is part of PonyProg.                                          //
//-------------------------------------------------------------------------//
//                                                                         //
//  PonyProg - Serial Device Programmer                                    //
//                                                                         //
//  Copyright (C) 1997-2001   Claudio Lanconelli                           //
//                                                                         //
//  e-mail: lancos@libero.it                                               //
//  http://www.LancOS.com                                                  //
//                                                                         //
//-------------------------------------------------------------------------//
//                                                                         //
// This program is free software; you can redistribute it and/or           //
// modify it under the terms of the GNU  General Public License            //
// as published by the Free Software Foundation; either version2 of        //
// the License, or (at your option) any later version.                     //
//                                                                         //
// This program is distributed in the hope that it will be useful,         //
// but WITHOUT ANY WARRANTY; without even the implied warranty of          //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       //
// General Public License for more details.                                //
//                                                                         //
// You should have received a copy of the GNU  General Public License      //
// along with this program (see COPYING);     if not, write to the         //
// Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. //
//                                                                         //
//-------------------------------------------------------------------------//
// $Id: pic168xx.h,v 1.1 2004/11/30 17:46:48 lancos Exp $
//=========================================================================//

#ifndef _PIC168XX_H
#define _PIC168XX_H

#include "pic16xx.h"
#include "picbusnew.h"

class Pic168xx : public Pic16xx
{
  public:		//---------------------------------------- public

	Pic168xx(e2AppWinInfo *wininfo = 0, BusIO *busp = 0);
	virtual ~Pic168xx();

	int Probe(int probe_size = 0);
//	int Read(int probe = 1, int type = ALL_TYPE);
	int Write(int probe = 1, int type = ALL_TYPE);
//	int Verify(int type = ALL_TYPE);

  protected:	//--------------------------------------- protected

	PicBus *GetBus()
		{ return (PicBusNew *)Device::GetBus(); }

	int QueryType(long &type);
	int CodeProtectAdjust(WORD &config, int read = 0);

  private:		//--------------------------------------- private

};
#endif
